unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,

  HTTPSend, ssl_openssl , Laz2_DOM, Laz2_XMLWrite;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  http: THTTPSend;
  XMLDoc: TXMLDocument;
  aRoot, aMethodName, aMethodValue: TDOMNode;
begin
  // XML Dokument erzeugen
  XMLDoc := TXMLDocument.Create;

  // Wurzelknoten erzeugen
  aRoot := XMLDoc.CreateElement('methodCall');
  XMLDoc.AppendChild(aRoot);

  // Kind Element erzeugen
  aRoot := XMLDoc.DocumentElement;
  aMethodName := XMLDoc.CreateElement('methodName');

  // Wert für Kind Element
  aMethodValue := XMLDoc.CreateTextNode('fldigi.version');
  aMethodName.AppendChild(aMethodValue);

  // Elemente sichern
  aRoot.AppendChild(aMethodName);

  // XML RPC Abfrage
  http := THTTPSend.Create;
  http.Sock.CreateWithSSL(TSSLOpenSSL); // <-- für https
  http.Sock.SSLDoConnect;               // <-- für https
  try
    WriteXML(XMLDoc, http.Document);
    if http.HTTPMethod('POST', '127.0.0.1:7362') then
      Memo1.Lines.LoadFromStream(http.Document);
  finally
    http.Free;
    XMLDoc.Free;
  end;
end;

end.

